# -*- coding: utf-8 -*-
"""
/***************************************************************************
 CIGeoEReshapeFeatures3D
                                 A QGIS plugin
 reshape a feature in 3D
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2019-04-05
        git sha              : $Format:%H$
        copyright            : (C) 2019 by Centro de Informação Geoespacial do Exército 
        email                : igeoe@igeoe.pt
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt5.QtCore import QSettings, QTranslator, qVersion, QCoreApplication
from PyQt5.QtGui import QIcon
from PyQt5.QtWidgets import QAction, QMessageBox, QToolBar

from qgis.core import QgsMapLayer, QgsWkbTypes

# Initialize Qt resources from file resources.py
from .resources import *
from .drawLine import drawLine

# Import the code for the dialog
from .CIGeoE_Reshape_Features_3D_dialog import CIGeoEReshapeFeatures3DDialog
import os.path


class CIGeoEReshapeFeatures3D:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'CIGeoEReshapeFeatures3D_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&CIGeoE Reshape Features 3D')

        # Check for CIGeoE toolbar. If exists, add button there; if not exists, create one
        cigeoeToolBarExists = False
        for x in iface.mainWindow().findChildren(QToolBar): 
            if x.windowTitle() == 'CIGeoE':
                self.toolbar = x
                cigeoeToolBarExists = True
        if cigeoeToolBarExists==False:
            self.toolbar = self.iface.addToolBar(u'CIGeoE')

        self.toolbar.setObjectName(u'CIGeoEReshapeFeatures3D')


        # Check if plugin was started the first time in current QGIS session
        # Must be set in initGui() to survive plugin reloads
        self.first_start = None


        #************* connect to drawline ******************
        self.drawisActive = False

        self.canvas = self.iface.mapCanvas()        
        self.drawline = drawLine(self.canvas, self.iface)           #add iface for work with active layer 
       
        #self.drawisActive = False

        #*********************************************

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('CIGeoEReshapeFeatures3D', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            #self.iface.addToolBarIcon(action)
            self.toolbar.addAction(action)                          #++  

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/CIGeoE_Reshape_Features_3D/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'CIGeoE Reshape Features 3D'),
            callback=self.run,
            parent=self.iface.mainWindow())

        # will be set False in run()
        self.first_start = True


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&CIGeoE Reshape Features 3D'),
                action)
            self.iface.removeToolBarIcon(action)

        #********************************************************
        # Unset the map tool in case it's set
        self.iface.mapCanvas().unsetMapTool(self.drawline)

        #*********************************************************

        # remove the toolbar
        del self.toolbar


    def run(self):
        """Run method that performs all the real work"""

        
        layer = self.iface.activeLayer()

        if not layer:
            QMessageBox.information(self.iface.mainWindow(), "Error", 'Layer is not loaded!')
            return  
                      
        
        if  layer.type() != QgsMapLayer.VectorLayer:         
            QMessageBox.information(self.iface.mainWindow(), "Error", 'Layer geometry must be of line or polygon type.')            
            return 

        if  layer.geometryType() != QgsWkbTypes.LineGeometry:
            if layer.geometryType() != QgsWkbTypes.PolygonGeometry:         
                QMessageBox.information(self.iface.mainWindow(), "Error", 'Layer geometry must be of line or polygon type.')            
                return           
                         
        if  self.drawisActive == False:
            self.iface.mapCanvas().setMapTool(self.drawline)                      
            self.drawisActive = True
        else:
            self.iface.mapCanvas().unsetMapTool(self.drawline)
            self.drawisActive = False

        self.iface.mapCanvas().refresh()